#ifndef COLLECTIONDUMPABLE_H
#define COLLECTIONDUMPABLE_H
#include"RACE_Dumpable.h"

//##Documentation
//##  Dumpable which keeps collections which can grow
//##

class RACE_CollectionDumpable : public virtual RACE_Dumpable
{
public:
  RACE_CollectionDumpable(size_t s):RACE_Dumpable(s) {}
//##Documentation
//##  the number of entryies in the collection Container

  virtual size_t Count() = 0;
//##Documentation
//##  the length of an entry

  virtual size_t GetEntryLength() = 0;
//##Documentation
//##  allocates a new element at the end

  char *Append();

  virtual void SetTimestamp()=0;
protected:
  virtual ~RACE_CollectionDumpable () {}
  RACE_CollectionDumpable():RACE_Dumpable() {}
//##Documentation
//##  updates the internal data Structure

  virtual void AppendUpdate()=0;
};
#endif
