#include"RACE_Data_Block.h"
#include<stdlib.h>

void RACE_Data_Block_Factory::informduplicate(RACE_Data_Block *)
{
}

void RACE_Data_Block_Factory::informrelease(RACE_Data_Block *)
{
}

RACE_Data_Block *RACE_Data_Block_Factory::create(char *buffer,size_t size,bool withcontent)
{
  RACE_Data_Block *ret;
  ret= new RACE_Data_Block(this,buffer,size,withcontent);
  RACE_MEMORY_FAIL(ret==NULL,__FILE__,__LINE__,__FUNCTION__);
  return ret;
}

void RACE_Data_Block_Factory::destroy(RACE_Data_Block *schrott)
{
  delete schrott;
}

static RACE_Simple_Malloc_Data_Block_Factory smdbf;
RACE_Data_Block* RACE_Data_Block::alloc(size_t size) throw (NoMoreDynamicMemory)
{
  return smdbf.generate(size);
}

RACE_Data_Block* RACE_Data_Block::clone() throw (NoMoreDynamicMemory)
{
  RACE_Data_Block* ret=smdbf.generate(length());
  ret->grow(length());
  memcpy(ret->basis,begin(),length());
  return ret;
}

RACE_Data_Block::~RACE_Data_Block()
{
}

RACE_Data_Block *RACE_Data_Block::duplicate()
{
  ACE_GUARD_RETURN(ACE_Thread_Mutex, ace_mon, this->refcountmutex_,0);
  reference_count_++;
  dbf_->informduplicate(this);
  return this;
}

void RACE_Data_Block::release()
{
  refcountmutex_.acquire();
  reference_count_--;
  if(reference_count_ == 0)
  {
    refcountmutex_.release();
    dbf_->recycle(this); // recycle calls implizitly informrelease
  }
  else
  {
    dbf_->informrelease(this);
    refcountmutex_.release();
  }
}

void RACE_Data_Block::grow(size_t n) throw (BufferOverflow)
{
  if(n>freespace()) throw BufferOverflow(freespace(),n);
  cur_size_+=n;
}


RACE_Data_Block *RACE_Simple_Malloc_Data_Block_Factory::generate(size_t size) throw (NoMoreDynamicMemory)
{
  RACE_Data_Block* ret;

  if(size>0)
  {
    ret=create((char *)malloc(size),size,false);
    RACE_MEMORY_FAIL(ret->begin()==NULL,__FILE__,__LINE__,__FUNCTION__);
  }
  else
  {
    ret=create(NULL,0);
  }

  RACE_MEMORY_FAIL(ret==NULL,__FILE__,__LINE__,__FUNCTION__);
  return ret;
}

void RACE_Simple_Malloc_Data_Block_Factory::recycle(RACE_Data_Block *schrott)
{
  free((void *)(schrott->begin()));
  destroy(schrott);
}


