#ifndef RACE_EXCEPTIONS_H
#define RACE_EXCEPTIONS_H
#include<exception>



//##Documentation
//## This exception is raised, when a block is full
//## One possible handling is to allocate a second block
class BufferOverflow : public std::exception
{
public:
  BufferOverflow(size_t free,size_t wanted):free_(free),wanted_(wanted)
  {
    snprintf(errmsg_,128,"BufferOverflow: %d wanted %d free",wanted_,free_);
  }
  size_t free()   { return free_; }
  size_t wanted() { return wanted_; }
  virtual const char *what() const throw()
  {
    return errmsg_;
  }
protected:
  size_t free_;
  size_t wanted_;
  char errmsg_[128];
};
#endif

