#ifndef RACE_LOGFILENAME_H__
#define RACE_LOGFILENAME_H__

class RACE_LogFileName {
  public:
    RACE_LogFileName (const char* basename, const char* extension);
    RACE_LogFileName (const char* basenamepath, const char* basenamefile, const char* extension);
    RACE_LogFileName (const RACE_LogFileName& original);
    RACE_LogFileName& operator= (const RACE_LogFileName& original);
    virtual ~RACE_LogFileName ();

    char* get_versioned_fullname (unsigned version) const; // caller should call delete []
    char* get_copiedfullname () const; // caller should call delete []
    const char* get_fullname () const { return m_fullname; }

    const char* get_basename () const { return m_basename; }
  private:
    void set (const char* basename, const char* extension);
    void reset ();
    char* m_basename;
    char* m_extension;
    char* m_fullname;
};

class RACE_IndexFileName : public virtual RACE_LogFileName {
  public:
    RACE_IndexFileName (const char* basename) : RACE_LogFileName (basename, "idx") {}
    RACE_IndexFileName (const RACE_IndexFileName& original) : RACE_LogFileName (original) {}
    RACE_IndexFileName& operator= (const RACE_IndexFileName& original)
      { RACE_LogFileName::operator= (original); return *this; }
    virtual ~RACE_IndexFileName () {}
};

#endif
