#include <time.h>
#include <stdio.h>
#include "RACE_LogIndexPositioner.h"

/**
 *  RACE_LogIndexPositioner_test <indexfile> [HH:MM:SS]
 *  * Reads and prints an index for a RACE-Logfile or a RACE-Depository.
 *  * With time given with the format HH:MM:SS it shows the entrynumber
 *    and the offset in the logfile.
 */
int main(int argc,char **argv)
{
  RACE_LogIndexPositioner positioner;
  if (argc < 2)
  {
    fprintf(stderr, "invocation: %s <indexfilename>\n", argv[0]);
    return 1;
  }
  char *indexfilename = argv[1];
  if (! positioner.Open(indexfilename) || positioner.IsEmpty())
  {
    printf("LogIndex is empty or not existent - the whole logfile needs to be read\n");
  }
  positioner.Print();
  try
  {
  RACE_LogfileOffset last = positioner.GetLastOffset();
  printf("LastOffset: %u:%u\n", last.part, (unsigned)last.offset);
  }
  catch(RACE_LogIndexPositioner::RangeError& ex)
  {
    fprintf(stderr,"%s\n",ex.What());
  }
  if(argc>2)
  {
    time_t wst=positioner.StrToTime(argv[2]);
    printf("Start bei index %u\n",positioner.GetLastIndex(wst));
    try
    {
      printf("Offset: %u:%u\n",
             positioner[positioner.GetLastIndex(wst)].offset.part,
             (unsigned) positioner[positioner.GetLastIndex(wst)].offset.offset
             );
    }
    catch(RACE_LogIndexPositioner::RangeError& ex)
    {
      fprintf(stderr,"%s\n",ex.What());
    }
  }
  return 0;
}

