#ifndef RACE_LOGINDEXWRITER_H
#define RACE_LOGINDEXWRITER_H
#include "RACE_LogIndexLayout.h"
#include "RACE_LogFileName.h"

//##Documentation
//## Writes an index for a logfile (timestamp, offset.)
//## The offset points into the snapshot file.
//## RACE_LogIndexWriter writes an array of RACE_LogIndexLayout.
class RACE_LogIndexWriter
{
public:
  RACE_LogIndexWriter():m_indexname(0),m_fdi(-1) {}
  ~RACE_LogIndexWriter();
  void Open(const char *basefilename);
  //##Documentation
  //## renames an old index file to a versioned index file
  void SaveOldIndex(const char *basefilename,int version=1);
  //##Documentation
  //## removes an old version of a indexfile
  void RemoveVersion(const char *basefilename,int version=1);
  void WriteEntry(time_t unixtime,RACE_LogfileOffset offset);
  void Close();
  //##Documentation
  //## deletes the Indexfile
  void Remove();
private:
  void set_indexname (const char* basename);
  RACE_IndexFileName* m_indexname;
  int m_fdi;
};
#endif
