#include <stdlib.h>
#include "errorhandling/envdebug.h"
#include "errorhandling/errorhandling.h"
#include "RACE_LogSwitchingStrategy.h"

envdebug *RACE_LogSwitchingStrategy::ms_debug = new envdebug("RACE_LogSwitchingStrategy");

void RACE_LogSwitchingStrategy::InfoCurrentOffset(off_t offset)
{
  ms_debug->print("LogSwitchingStrategy::InfoCurrentOffset(%ld)",offset);
  m_CurrentOffset = offset;
  if(offset > m_Hardlimit)
  {
    ms_debug->print("LogSwitchingStrategy::InfoCurrentOffset: %ld >HARDLIMIT(%ld)",offset,m_Hardlimit);
    mp_LogSwitcher->SwitchLog();
  }
}

RACE_DefaultLogSwitchingStrategy::RACE_DefaultLogSwitchingStrategy(RACE_LogSwitcher *ls)
  :RACE_LogSwitchingStrategy(ls),m_Softlimit(1<<25)
{
  const char *envstr;
  if((envstr=getenv("RACE_LOGFILESIZE_HARDLIMIT_MB"))!=NULL)
  {
    m_Hardlimit=atol(envstr)<<20;
  }
  if((envstr=getenv("RACE_LOGFILESIZE_SOFTLIMIT_KB"))!=NULL)
  {
    m_Softlimit=atol(envstr)<<10;
  }
  ms_debug->print("RACE_DefaultLogSwitchingStrategy: hardlimit=%ld softlimit=%ld",
               m_Hardlimit,m_Softlimit);
  RACE_COND_FAIL(m_Hardlimit < (1<<20),"RACE_LOGFILESIZE_HARDLIMIT_MB < 1 ");
#ifdef FOR_REAL_APPLICATION
  RACE_COND_FAIL(m_Softlimit < (1<<10),"RACE_LOGFILESIZE_SOFTLIMIT_KB < 1 ");
#endif
}

void RACE_DefaultLogSwitchingStrategy::InfoSnapshotWritten()
{
  if(m_CurrentOffset >= m_Softlimit)
  {
    ms_debug->print("InfoSnapshotWritten: SOFTLIMIT");
    mp_LogSwitcher->SwitchLog(); // Accumulator in the logger has already written
  }
}
