#ifndef RACE_LOGFILE_H
#define RACE_LOGFILE_H
#include "RACE_LogfileBase.h"
#include "RACE_LogIndexWriter.h"
#include "RACE_LogfileOffset.h"

//##Documentation
//## Encapulates the writing of the Logfile
//##
//##  splitting the Logfile in parts,
//##  It is independed of content
class RACE_Logfile : public RACE_LogfileBase
{
  public:
    RACE_Logfile();

    virtual ~RACE_Logfile();

    virtual void Open(const char *filename) throw (Systemerror);
    void SetFilenameBody(const char *basename);
    virtual void Open() throw (Systemerror);
    //##Documentation
    //## from RACE_WriterInterface
    int WriteV(const iovec *io, int count) throw (Systemerror);

    //##Documentation
    //## from RACE_WriterInterface
    virtual int PartNo();

    void Close();

    virtual void SwitchPart() throw (Systemerror);

    virtual const char *GetBasename() const;
 private:
    void OpenPart() throw (Systemerror);

    //##Documentation
    //## current Filehandle
    int m_fd;

    char m_filename[128];
    char m_bodyname[128];
    int m_partno;
};



#endif /* RACE_LOGFILE_H */

