#ifndef RACE_LOGFILE_OFFSET_H
#define RACE_LOGFILE_OFFSET_H
#include <sys/types.h>
#include <stdint.h>

//##Documentation
//## This class implements offsets for partitioned logfiles.
struct RACE_LogfileOffset
{
  /// the number of the part, 0 is the tds-File
  int32_t part;
  /// the offset in the part.
  int32_t offset;

  RACE_LogfileOffset():part(0),offset(0) {}
  RACE_LogfileOffset(int32_t ppart, int32_t poffset)
    : part(ppart), offset(poffset) {}

  bool IsNil() const { return part==0 && offset==0; }
};
#endif
