#ifndef RACE_LOGGERSTRATEGY_H
#define RACE_LOGGERSTRATEGY_H
#include"RACE_LoggerQLS.h"
//##Documentation
//## for controlling the Logger
class RACE_LoggerStrategy : public RACE_LoggerQLS
{
public:
  enum TerminateCause { TC_NORMAL=0,TC_EXCEPTION=-1 };
  RACE_LoggerStrategy(const char *queuename);
  //##Documentation
  //## called from the logger 
  virtual long periode_in_s();
  //##Documentation
  //## the may have tasks like triggering a snapshot
  //## the logger calls this periodically
  virtual void periodic_callback(time_t now);
  virtual ACE_Time_Value *GetCurrentDequeueTimeout();
  //##Documentation
  //## Called by the logger when it terminates
  virtual void logger_terminated(TerminateCause tc);
private:
  long periode_in_s_;
  ACE_Time_Value m_currentAbsolutTimeout;
};
#endif

