#include"RACE_Periodic_Work.h"

RACE::Periodic_Work::Periodic_Work(ACE_Time_Value period):period_(period)
{
}

RACE::Periodic_Work::~Periodic_Work()
{
}

ACE_Time_Value RACE::Periodic_Work::getPeriod()
{
    return period_;
}

void RACE::Periodic_Work::atstart()
{
   // default: do nothing
}

RACE::EventHandlerAdapter::EventHandlerAdapter(Periodic_Work *work)
    :work_(work),timerid_(-1),reactor_(0)
{
}

RACE::EventHandlerAdapter::~EventHandlerAdapter()
{
    delete work_;
}

int
RACE::EventHandlerAdapter::handle_timeout(const ACE_Time_Value &current_time,
                              const void * /*act*/)
{
    return work_->do_work(current_time);
}

long
RACE::EventHandlerAdapter::register_at_reactor(ACE_Reactor *reactor)
{
    ACE_Time_Value delay(work_->getPeriod());
    reactor_=reactor;
    timerid_=reactor->schedule_timer(this,0,delay,work_->getPeriod());
    return timerid_;
}

void
RACE::EventHandlerAdapter::cancel_timer()
{
    reactor_->cancel_timer(timerid_);
    timerid_=-1;
}
