#include<time.h>
#include"RACE_Thread.h"
#include<errorhandling/RACE_LogMsg_Stream.h>

class Sleeper : public RACE_Thread
{
public:
    Sleeper():RACE_Thread() {}
protected:
    virtual void run();
};

void 
Sleeper::run()
{
    struct timespec sleepingtime;
    sleepingtime.tv_sec=2;sleepingtime.tv_nsec=0;
    ERRLOG << "sleeping 2 seconds " << E_EOM;
    nanosleep(&sleepingtime,0);
    ERRLOG << "Wake up from sleep and terminate " << E_EOM;
}

#ifdef THREADWAITER
class threadwaiter
{
public:
    ~threadwaiter()
    {
	RACE_Thread::wait_for_all_threads();
    }
} stobj;
#endif

int 
main(int argc,char **argv)
{
    bool joinonly=true;
    RACE_LOGMSGBACKEND::instance()->init(argc,argv);
    char **arg=argv+1;
    while(*arg!=0)
    {
	if(strcmp(*arg,"-sc")==0)
	{
	    joinonly=false;
	}
	arg++;
    }
    
#ifdef TIME_SYNC
    struct timespec sleepingtime;
    sleepingtime.tv_sec=1;sleepingtime.tv_nsec=0;
#endif
    Sleeper *sleeper = new Sleeper();
    sleeper->start();
#ifndef TIME_SYNC
    sleeper->waitforStatechanging();
    ERRLOG << "Sleeper sleeps ... " << E_EOM;
#else
    nanosleep(&sleepingtime,0);
#endif
    if(!joinonly)
    {
	sleeper->waitforStatechanging();
    }
    sleeper->wait();
    sleeper->release();
}
