#include<errorhandling/errorhandling.h>
#include"RACE_Depot.h"

static envdebug *debug=new envdebug("RACE_Depot");

void RACE_Depot::Open(const char *name) throw (Systemerror)
{
  RACE_Depository::Open(name);
}

void RACE_Depot::SwitchPart() throw (Systemerror)
{
  RACE_Depository::SwitchPart();
  debug->print("RACE_Depot::SwitchPart: Put the Content into the queue");
  collector_->RewriteAllAndClear();
  oldlogdeletionpending_=true;
}
// Note: SwitchPart is indirectly called from the LogSwitchingStrategy,
// InformSnapshot must be called at the first snapshot and not when
// the LogSwitchingStrategy decides to swich at the 10. Snapshot

void RACE_Depot::Recover()
{
  if(!WasRecovered())
  {
    debug->print("RACE_Depot Recover: no old Logfile");
    return;
  }
  bool successfull=readerdriver_.Open(GetOldFilename());
  RACE_COND_FAIL(!successfull," RACE_Depot::Recover: Can't open %s ",GetOldFilename());
  readerdriver_.readlastsnapshot();
  readerdriver_.readuntilend();
  oldlogdeletionpending_=true;
}

void RACE_Depot::InformSnapshot()
{
  if(oldlogdeletionpending_)
  {
    RemoveOld();
    oldlogdeletionpending_=false;
  }
}
