#include<errorhandling/errorhandling.h>
#include"RACE_Interpreter.h"
#include"RACE_Layout_GeneralHeader.h"
#include<iostream>

bool RACE::Interpreter::setcontent(RACE_LogfileOffset lo,RAMS::octet_t *content,size_t len)
{
    if(len<sizeof(Layout::GeneralHeader)) return false;
    content_=content;
    return true;
}

size_t RACE::Interpreter::length()
{
    return ((Layout::GeneralHeader *)content_)->len;
}

RACE_Dumpable *RACE::Interpreter::interpret(RACE_Data_Block *db,bool fragmented,RACE_LogfileOffset lo)
{
  int count=0;
  RACE_Dumpable *ret=new RACE_Dumpable(db,fragmented,lo);
  RACE_MEMORY_FAIL(ret==NULL,__FILE__,__LINE__,__FUNCTION__);
  RACE::Layout::GeneralHeader *gh=
    (RACE::Layout::GeneralHeader *)(ret->first_base());
  std::cerr << "At Offset " << ret->GetOffset().part << ':'
            << ret->GetOffset().offset
            <<  " Type: " << gh->type << " ";
  if(fragmented)
  {
    std::cerr << "Fragmented: ";
  }
  for(ret->begin();!ret->is_done();ret->advance())
  {
    std::cerr << ret->length() << " ";
    count++;
  }
  std::cerr << " = " << ret->total_length() << " in " << count << " blocks"
            << std::endl;
  return ret;
}

size_t RACE::Interpreter::lengthofchain(RACE_Data_Block *db)
{
  size_t ret=0;
  for(RACE_Data_Block *i=db;i!=0;i=i->next)
  {
    ret+=i->length();
  }
  return ret;
}

RACE_Data_Block *RACE::Interpreter::defragment(RACE_Data_Block *db)
{
  RACE_Data_Block *ret=RACE_Data_Block::alloc(lengthofchain(db));
  RACE_Data_Block *weg=0;
  char *p=(char *)(ret->begin());

  for(RACE_Data_Block *i=db;i!=0;i=i->next)
  {
    if(weg) { weg->release(); }
    ret->grow(i->length());
    memcpy(p,i->begin(),i->length());
    p+=i->length();
    weg=i;
  }
  if(weg) { weg->release(); }
  return ret;
}
