#ifndef RACE_INTERPRETER_H
#define RACE_INTERPRETER_H
#include<RAMS/elementartypes.h>
#include<RACE_Data_Block.h>
#include<RACE_Dumpable.h>
#include<RACE_Layout_GeneralHeader.h>

namespace RACE
{
  class Interpreter
  {
  public:
    Interpreter():content_(0) {}
    virtual bool setcontent(RACE_LogfileOffset lo,RAMS::octet_t *content,size_t len);
    virtual size_t length();
    //##Documentation
    //## simple default-Interpreter
    virtual RACE_Dumpable *interpret(RACE_Data_Block *db,bool fragmented,RACE_LogfileOffset lo);
  protected:
    //##Documentation
    //## sums the length() of all elements in the chain
    static size_t lengthofchain(RACE_Data_Block *db);
    //##Documentation
    //## copies all fragments in one block (alloced eith simplemallovfactory)
    //## and release the fragments
    static RACE_Data_Block *defragment(RACE_Data_Block *db);

    RAMS::octet_t *content_;
  };
};
#endif

