#include<iostream>
#include<errorhandling/errorhandling.h>
#include"RACE_LogIndexPositioner.h"
#include"RACE_ReaderDriver.h"

void RACE_ReaderDriver::readuntilend()
{
  RACE_Dumpable *dumpable;
  int retry=0;
  do
  {
    try
    {
      while((dumpable=reader_.Read())!=NULL)
      {
          dumpable->CallVisitor(semantic_);
          dumpable->release();
      }
    }
    catch(RACE::ReadError& ex)
    {
        std::cerr << "ReadError: " << ex.what() << std::endl;
    }
  } while(retry>0);
  reader_.Close();
}

void RACE_ReaderDriver::readsnapshot(RACE_LogfileOffset wantedoffset)
{
  RACE_Dumpable *dumpable;

  try
  {
    if((dumpable = reader_.ReadAt(wantedoffset))!=NULL)
    {
      dumpable->CallVisitor(snapshotsemantic_);
      dumpable->release();
    }
    else
    {
      std::cerr << "Position not found " << std::endl;
    }
  }
  catch(RACE::ReadError& ex)
  {
    std::cerr << ex.what() << std::endl;
  }
}

void RACE_ReaderDriver::readsnapshotattime(const char *timestr)
{
  RACE_LogIndexPositioner positioner(reader_.GetIndexFilename());
  RACE_LogfileOffset wantedoffset;
  try
  {
    if(!positioner.IsEmpty())
    {
      time_t time = positioner.StrToTime(timestr);
      wantedoffset = positioner.Get(time);
      readsnapshot(wantedoffset);
    }
  }
  catch(RACE_LogIndexPositioner::RangeError& ex)
  {
    std::cerr << ex.What() << std::endl;
  }
}

void RACE_ReaderDriver::readlastsnapshot()
{
  RACE_LogIndexPositioner positioner(reader_.GetIndexFilename());
  RACE_LogfileOffset wantedoffset;
  try
  {
    if(!positioner.IsEmpty())
    {
      wantedoffset = positioner.GetLastOffset();
      readsnapshot(wantedoffset);
    }
  }
  catch(RACE_LogIndexPositioner::RangeError& ex)
  {
    std::cerr << ex.What() << std::endl;
  }
}
