#ifndef RACE_READERDRIVER_H
#define RACE_READERDRIVER_H
#include"RACE_LogfileReader.h"
#include"RACE_LogIndexPositioner.h"
#include"RACE_Interpreter.h"

class RACE_ReaderDriver
{
public:
  RACE_ReaderDriver():reader_(0,0),interp_(0),semantic_(0),snapshotsemantic_(0) {}
  bool Open(const char *name) { return reader_.Open(name); }
  void Close() { reader_.Close(); }
  void readuntilend();
  void readsnapshotattime(const char *timestr);
  void readlastsnapshot();
  void readsnapshot(RACE_LogfileOffset wantedoffset);
  RACE::LogFileReader *Reader() { return &reader_; }
  void SetInterpreter(RACE::Interpreter *inter)
  {
      interp_=inter;
      reader_.SetInterpreter(interp_);
  }
  void SetIterationSemantic(RACE_MessageVisitor *semantic)
  {
    semantic_=semantic;
  }
  void SetSnapshotSemantic(RACE_MessageVisitor *semantic)
  {
    snapshotsemantic_=semantic;
  }
private:
  RACE::LogFileReader reader_;
  RACE::Interpreter *interp_;
  RACE_MessageVisitor *semantic_;
  RACE_MessageVisitor *snapshotsemantic_;
};
#endif
