#include<iostream>
#include"RACE_ReaderDriver.h"
#include"RACE_SemanticFactory.h"

RACE_ReaderDriver readerdriver;
RACE_Semantik_Factory sf(readerdriver.Reader());
void usage()
{
    std::cerr << "Aufruf: " << RACE_LOGMSGBACKEND::instance()->progname()
              << " logfile part:offset \n"
              << " logfile -t hh:mm:ss \n"
              << " logfile -l \n"
              << std::endl;
}

int main(int argc,char **argv)
{
  RACE_LOGMSGBACKEND::instance()->init(argc,argv);
  sf.init(argc,argv);
  readerdriver.SetInterpreter(sf.interpreter());
  readerdriver.SetIterationSemantic(sf.iterationsemantic());
  readerdriver.SetSnapshotSemantic(sf.snapshotsemantic());

  if(argc<3) { usage(); return -1;}
  if(!readerdriver.Open(argv[1]))
  {
    std::cerr << "Can't open " << argv[1] << std::endl;
    exit(1);
  }
  if(!readerdriver.Open(argv[1]))
  {
    std::cerr << "Can't open " << argv[1] << std::endl;
    exit(1);
  }
  if(argc>2)
  {
    RACE_LogfileOffset wantedoffset;
    if(strcmp(argv[2],"-t")==0)
    {
      readerdriver.readsnapshotattime(argv[3]);
    }
    else if(strcmp(argv[2],"-l")==0)
    {
      readerdriver.readlastsnapshot();
    }
    else if(sscanf(argv[2],"%d:%d",&(wantedoffset.part),&(wantedoffset.offset))==2)
    {
      readerdriver.readsnapshot(wantedoffset);
    }
    else
    {
      usage();
      readerdriver.Close();
      return -1;
    }
  }
  return 0;
}
