#ifndef LSDIFFPAGEDUMPABLE_H
#define LSDIFFPAGEDUMPABLE_H
#include"LSDumpable.h"

class LSDiffPageDumpable : public LSDumpable
{
public:
  //##Documentation
  //## Constructor for diff pages
  LSDiffPageDumpable(RACE_Data_Block *header,RAMS::Mseg *page,RAMS::Mseg *oldcontent);

  //##Documentation
  //## Constructor for Interpreters
  LSDiffPageDumpable(RACE_Data_Block *db,RACE_LogfileOffset lo):
    LSDumpable(db,lo) {}


  //##Documentation
  //## calculate xor diff from page
  void calculatediff(LSlayout::logpageheader *,RAMS::Mseg *page,RAMS::Mseg *oldcontent);

  //##Documentation
  //## apply diff on a page
  void applydiff(void *pageaddress);
  virtual void CallVisitor(RACE_MessageVisitor *visitor);
protected:
  off_t getOffsetInPage() { return pageheader()->offset_in_page; }
  RAMS::octet_t *diffstart() { return (RAMS::octet_t *)(pageheader()->page); }
  size_t difflen() { return pageheader()->len_of_page; }
};

#endif
