#include"LSLogInterpreter.h"
#include"LSpersistentlayout.h"
#include"LSFullPageDumpable.h"
#include"LSDiffPageDumpable.h"

static envdebug *debug = new envdebug("LSLogInterpreter");

RACE_Dumpable *LSLogInterpreter::interpret(RACE_Data_Block *db,bool frag,RACE_LogfileOffset lo)
{
  RACE_Dumpable *ret;
  LSlayout::logpageheader *header = (LSlayout::logpageheader *)(db->begin());
  debug->print("Type %d ",header->type);
  switch(header->type)
  {
  case LSlayout::full:
    ret = new LSFullPageDumpable((frag ? defragment(db) :db),lo);
    break;
  case LSlayout::diff:
    ret = new LSDiffPageDumpable((frag ? defragment(db) :db),lo);
    break;
  default:
    RACE_WARN("KVInterpreter::interpret: Unknown Dumpable %d",header->type);
    ret=new RACE_Dumpable(db,frag,lo);
  }
  RACE_MEMORY_FAIL(ret==NULL,__FILE__,__LINE__,__FUNCTION__);
  return ret;
}
