#ifndef LSPAGEDESCRIPTOR_H
#define LSPAGEDESCRIPTOR_H
#include"LSpersistentlayout.h"
#include"RACE_Data_Block.h"

class PageSeg : public RAMS::Mseg
{
public:
  PageSeg(): RAMS::Mseg() {}
  void set(char *anfang,size_t lang) { setto(anfang,lang); }
};

class LSeg;
class LSPagedescriptor
{
public:
  LSPagedescriptor():pageseg_(),index_(0),lseg_(0),dirty_(false),count_(-1),
                     pageheader_(0),beforeimage_(0) {}
  void init(LSeg *lseg,RAMS::PageNo_t i);
  void touch();
  bool isdirty() { return dirty_; }
  void logchangesifneeded() { if(isdirty()) {logchanges(); } }
  void logchanges();
  void rollbackifneeded() { if(isdirty()) { rollback(); }}
  void rollback();
private:
  PageSeg pageseg_;
  RAMS::PageNo_t index_;
  LSeg *lseg_;
  bool dirty_;
  int count_; //-1: no // 0: full // > 1 numberof diffs since full
  LSlayout::logpageheader *pageheader()
    { return pageheader_ ? (LSlayout::logpageheader *)(pageheader_->begin())
                         : 0;
    }
  RACE_Data_Block *pageheader_;
  RACE_Data_Block *beforeimage_;
};

#endif
