#include<iostream>
#include"LSeg.h"
#include<RAMS/rpointer.h>

LSeg seg;

int main(int argc,char **argv)
{
  int iter=1;
  int rollback=0;
  int crash=0;
  int optind=1;
  char **optarg=argv+1;
  const char *basename=NULL;
  while(optind<argc && **optarg=='-')
  {
      if(strcmp(*optarg,"-rollback")==0) rollback=1;
      else if(strcmp(*optarg,"-crash")==0) crash=1;
      optarg++;
      optind++;
  }
  if(argc-optind<1)
  {
    std::cerr << "Usage: " << argv[0] << " basename [iter] " << std::endl;
    exit(1);
  }
  basename=*optarg++;
  optind++;
  if(argc-optind>1)
  {
      iter=atoi(*optarg);
  }
  try
  {
    seg.open(basename);
    RAMS::Mseg *ms=&seg;

    for(int i=0;i<iter;i++)
    {
        RAMS::RPointer<char> lptr(1,ms);
        std::cout << " Iteration " << i << std::endl;
        char w = *lptr;
        std::cout << "Auf Offset " << lptr.offset() << ":" << w << std::endl;
        *lptr=(w=='\0' ? 'A' : w+1 );
        lptr+=4096;
        w = *lptr;
        std::cout << "Auf Offset " << lptr.offset() << ":" << w << std::endl;
        *lptr=(w=='\0' ? 'M' : w+1 );
        if(crash)
        {
            exit(1);
        }
        if(!rollback)
        {
            seg.checkpoint();
        }
        else
        {
            seg.rollback();
        }

    }
    seg.close();
  }
  catch(std::exception &ex)
  {
    std::cerr << ex.what() << std::endl;
  }
}
