#include<stdlib.h>
#include<stdio.h>
#include<errno.h>
#include<sys/mman.h>
#include<errorhandling/errorhandling.h>
#include"pmseg.h"

static envdebug debug("RAMS_HVSEG_pmseg");
PMSeg* PMSeg::wurzel=NULL;

void PMSeg::sigseg(int sig,siginfo_t *siginfo, void *unkown)
{
  debug.print("SEGV catched:\n");
  char *p = (char *)((long)(siginfo->si_addr)&~(PAGESIZE-1));
  debug.print("Error at ptr=%p page=%p ",siginfo->si_addr,p);
  switch(siginfo->si_code)
  {
  case SEGV_MAPERR: debug.print("address not mapped to object\n");
                    break;
  case SEGV_ACCERR: debug.print("invalid permissions for mapped object\n");
                    break;
  default:
    debug.print("unknown\n");
  }
  if(siginfo->si_code == SEGV_ACCERR)
  {
    PMSeg *seg;
    if((seg=PMSeg::lookup(siginfo->si_addr))!=NULL)
    {
      RAMS::PageNo_t pageno = seg->pageno(p);
      debug.print("Hebe Sperrung von Seite %ld auf",pageno);
      seg->handle(pageno,siginfo->si_addr);
      seg->unprotect(pageno);
      return;
    }
  }
  debug.print("Anderer SEGV ...\n");
  struct sigaction sa;
  sa.sa_flags=0;
  sigemptyset(&(sa.sa_mask));
  sa.sa_handler = SIG_DFL;
  sigaction(SIGSEGV,&sa,NULL);
}

void PMSeg::insert(PMSeg *diese)
{
  debug.print("pmseg::insert(%p,%d)",diese->begin(),diese->size());
  if(wurzel==NULL)
  {
    debug.print("Initialisiere Signalhandler \n");
    struct sigaction sa;
    sa.sa_flags = SA_SIGINFO|SA_RESTART;
    sigemptyset(&(sa.sa_mask));
    sa.sa_sigaction = sigseg;
    sigaction(SIGSEGV,&sa,NULL);
  }
  PMSeg **akt = &wurzel;
  while((*akt)!=NULL && (*akt)->begin() < diese->begin())
  {
    akt=&((*akt)->next);
  }
  diese->next=*akt;
  *akt = diese;
}

void PMSeg::remove(PMSeg *diese)
{
  PMSeg **akt = &wurzel;
  while((*akt)!=NULL && (*akt)->begin() < diese->begin())
  {
    akt=&((*akt)->next);
  }
  if(*akt==diese)
  {
    *akt=(*akt)->next;
  }
}

PMSeg *PMSeg::lookup(void *addr)
{
  PMSeg *akt=wurzel;
  while( akt!= NULL && akt->begin() <=  addr  )
  {
    if(akt->begin() <= addr && addr <= (char *)(akt->end()))
    {
      return akt;
    }
    akt = akt->next;
  }
  return NULL;
}

PMSeg::PMSeg(char *anfang,size_t len): RAMS::Mseg(anfang,len)
{
  insert(this);
}

void PMSeg::set(char *anfang,size_t lang)
{
  setto(anfang,lang);
  insert(this);
}

void PMSeg::protect(RAMS::PageNo_t pageno)
{
  int r=mprotect(pageno2addr(pageno),PAGESIZE,PROT_READ);
  RACE_COND_FAIL(r<0,"PMSeg::protect: mprotect: %s ",strerror(errno));}

void PMSeg::unprotect(RAMS::PageNo_t pageno)
{
  int r=mprotect(pageno2addr(pageno),PAGESIZE,PROT_WRITE|PROT_READ);
  RACE_COND_FAIL(r<0,"PMSeg::protect: mprotect: %s",strerror(errno));
}

PMSeg::~PMSeg()
{
  remove(this);
}
