#include"growingpersistentmseg.h"
#include<unistd.h>
#include<sys/mman.h>
#include<fcntl.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<sys/errno.h>

using namespace RAMS;

int PersistentGrowingMseg::init(const char *filename) throw (Systemerror)
{
  gmflags = MAP_SHARED;
  struct stat sb;
  fd=open(filename,O_RDWR|O_CREAT,S_IRUSR|S_IWUSR);
  if(fd<0)
  {
    throw Systemerror(errno,"open","PersistentGrowingMseg::init:open(%s):%m",filename);
  }
  if(fstat(fd,&sb)<0)
  {
    throw Systemerror(errno,"stat","PersistentGrowingMseg::init:stat(%s):%m",filename);
  }
  size_=sb.st_size;
  if(size_>0)
  {
    basis=(char *)mmap(NULL,size_,PROT_READ|PROT_WRITE,gmflags,fd,0);
    if(basis==MAP_FAILED) 
    {
      throw Systemerror(errno,"mmap","PersistentGrowingMseg::init:mmap(%s):%m",filename);
    }
    ende=(char *)basis+size_;
    return 0;
  }
  else
  {
    basis=ende=NULL;
    return 1;
  }
}

void PersistentGrowingMseg::grow_internal(int anzseiten) throw(Growingmseg::Error)
{
  char pseudo='\0';
  off_t r=lseek(fd,anzseiten*getpagesize()-1,SEEK_END);
  if(r==-1) throw Systemerror(errno,"lseek","PersistentGrowingMseg::lseek:%m");
  int w=write(fd,&pseudo,1);
  if(w<0)   throw Systemerror(errno,"write","PersistentGrowingMseg::write:%m");
}

