/**
 * @file growingpersistentmseg.h
 * @brief wachsendes Speichersegment mit Persistenz
 * @author <A href="http://www.infnet.verein.de/~rw/">Rudolf Weber</A> 2000
 */
#ifndef PERSISTENT_GROWING_MSEG
#define PERSISTENT_GROWING_MSEG
#include"growingmseg.h"

namespace RAMS
{
 /**
  * \brief Wachsendes Speichersegment
  *
  * Dieses Speichersegment kann mit der Operation grow wachsen.
  * Das Speichersegment ist auf eine Datei gemappt
  * Das vergrern der Datei erfogt mit lseek 
  */                                   
  class PersistentGrowingMseg : public Growingmseg
  {
  public:
    PersistentGrowingMseg() { }
    PersistentGrowingMseg(const char *filename) throw(Systemerror)
      {
	init(filename);
      }
    /**
     * @param filename zu mappender Filename
     * @return 1 if new, else 0
     * mappt eine Datei namens filename in den Speicher<br>
     * Falls Datei nicht gefunden wird, wird sie angelegt.<br>
     */
    int init(const char *filename) throw(Systemerror);
  protected:
    /**
     * mit lseek wird anzseiten weiter positioniert und dort ein byte 
     * geschrieben. Laut Manualpage lseek(2) werden die Loecher mit
     * '\0' vorbelegt.
     */
     virtual void grow_internal(int anzseiten) throw(Growingmseg::Error);
  };
};
#endif





