#include<unistd.h>
#include<sys/mman.h>
#include<fcntl.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<sys/errno.h>
#include"mmfile.h"

using namespace RAMS;

void MMFile::init(const char *filename) throw(Systemerror)
{
    struct stat sb;
    fd=open(filename,O_RDONLY);
    if(fd<0)
    {
	throw Systemerror(errno,"open","MMFile::init:open(%s):%m",filename);
    }
    if(fstat(fd,&sb)<0)
    {
	throw Systemerror(errno,"stat","MMFile::init:stat(%s):%m",filename);
    }
    size_=sb.st_size;

    basis=(char *)mmap(NULL,size_,PROT_READ,MAP_SHARED,fd,0);
    if(basis==MAP_FAILED) 
    {
	throw Systemerror(errno,"mmap","MMFile::init:mmap(%s):%m",filename);
    }
}


MMFile::~MMFile()
{
    if(basis) munmap(basis,size_);
     if(fd!=-1) close(fd);
}
