#include<iostream>
namespace RAMS
{
    typedef unsigned char octet_t;
};

inline u_int32_t getbitsimbyte(size_t off,size_t len, RAMS::octet_t b)
{
    size_t lm = (len < 8-off ? len : 8-off);
    size_t shift=(8-off-lm);
    u_int32_t ret=(b& ((~(~0ul<<len))<<shift));
    return (ret>>shift);
}

inline void setbitsimbyte(size_t off,size_t len, RAMS::octet_t &b,RAMS::octet_t set)
{
    size_t lm = (len < 8-off ? len : 8-off);
    RAMS::octet_t toset = (~(~0<<lm) & set);
    size_t shift=(8-off-lm);
    RAMS::octet_t mask  = ~(~0<<lm) << shift;
    b&=~mask; // clear bits
    b|=(toset<<shift);
}

void testbs(size_t off,size_t len,RAMS::octet_t test,RAMS::octet_t set)
{
    setbitsimbyte(off,len,test,set);
    u_int32_t bits = getbitsimbyte(off,len,test);
    std::cout << std::hex << (unsigned int)test << " " 
	      << bits 
	      << ((RAMS::octet_t)bits == set ? " OK " : " ERROR")
	      << std::endl;
    
}
int main()
{
    testbs(4,2,0,3);
    testbs(0,4,0,15);
    testbs(7,1,0,1);
}
