#include<iostream>
#include"segmentgrab.h"
#include"dumputility.h"
#include"bitgrabber.h"
void Usage()
{
    std::cerr << "Aufruf: segmentgrab file [--offset off] [--size s]"
	      << std::endl;
    exit(1);
}
SegmentGrab sgrab;

int main(int argc,char **argv)
{
    char *filename=0;
    off_t offset=0;
    size_t size=4096;
    char **arg=argv+1;
    filename = *arg;
    if(filename==0) { Usage(); }
    arg++;
    while(*arg!=NULL)
    {
	if(strcmp(*arg,"--offset")==0)
	{
	    char *ep=0;
	    ++arg;
	    if(*arg==0)
	    {
		std::cerr << "--offset: offset expected " << std::endl;
		Usage();
	    }
	    offset=::strtol(*arg,&ep,0);
	    if(*ep!='\0')
	    {
		std::cerr << "illegal char detected in offset " << std::endl;
		Usage();
	    }
	}
	else if(strcmp(*arg,"--size")==0)
	{
	    char *ep=0;
	    ++arg;
	    if(*arg==0)
	    {
		std::cerr << "--size: size expected " << std::endl;
		Usage();
	    }
	    size=::strtol(*arg,&ep,0);
	    if(*ep!='\0')
	    {
		std::cerr << "illegal char detected in size " << std::endl;
		Usage();
	    } 
	}
	arg++;
    }
    try
    {
	sgrab.load(filename,offset,size);
    }
    catch(std::exception &ex)
    {
	std::cerr << ex.what() << std::endl;
	exit(1);
    }
    RAMS::Mseg &seg=sgrab.seg();
    std::cout << "-------------------- Hexdump --------------------------\n";
    Dumputility::dump_hex(std::cout,(RAMS::octet_t *)seg.begin(),seg.size(),offset);
    std::cout << "-------------------- Asciidump ------------------------\n";
    Dumputility::dump_ascii(std::cout,(RAMS::octet_t *)seg.begin(),seg.size(),offset);
    RAMS::BitGrabber bitgrabber(seg);
    std::cerr << "command ?" << std::endl;
    RAMS::bitoff_t o;
    size_t l;
    char command;
    while(!(std::cin.eof()))
    {
	std::cin >> command;
	switch(command)
	{
	    case 'g':
                {
		std::cin >> o >> l;
		std::cout << std::dec << "offset=" << o << " len=" << l << std::endl;
		std::cout << std::hex << bitgrabber.getbits(o,l) << std::endl;
		}
		break;
	    case 's':
	        {
		    u_int32_t value;
		    std::cin >> o >> l >> value;
		    bitgrabber.setbits(o,l,value);
		}
		break;
	    case 'a':
		Dumputility::dump_ascii(std::cout,(RAMS::octet_t *)seg.begin(),seg.size(),offset);
		break;
	    case 'x':
		 Dumputility::dump_hex(std::cout,(RAMS::octet_t *)seg.begin(),seg.size(),offset);
		 break;
	    case 'w':
		sgrab.save(filename);
		break;
	    default:
		std::cerr << "set: s offset length value " << std::endl;
		std::cerr << "get: g offset value" << std::endl;
	}
	std::cerr << "command ?" << std::endl;
    }
}
