#include"segmentgrab.h"

void SegmentGrab::load(const char *filename,off_t off,size_t size) throw (Systemerror,Error)
{
    int fd = ::open(filename,O_RDONLY);
    if(fd<0)
    {
	throw Systemerror(errno,"open","SegmentGrab::load: Can't open %s: %m",
			  filename);
    }
    fileoffset_=(off & ~RAMS::OFFSETMASK);
    segoffset_ =(off &  RAMS::OFFSETMASK);
    if(fileoffset_!=0)
    {
	off_t r=::lseek(fd,fileoffset_,SEEK_SET);
	if(r==(off_t)(-1))
	{
	  throw Systemerror(errno,"lseek","SegmentGrab::load: lseek(%s,%x):%m",			      filename,fileoffset_);
	}
    }
    ssize_t nr=::read(fd,puffer,4096);
    if(nr<0) 
    {
	throw Systemerror(errno,"read","SegmentGrab::load: read(%s,%d) at %x:%m",			  filename,4096,fileoffset_);
    }
    if((size_t)(segoffset_+nr)<size)
    {
	throw Error("SegmentGrab::load: read only %ld bytes after offset %lx",
		    nr-segoffset_,fileoffset_);
    }
    seg_.init(puffer+segoffset_,size);
    close(fd);
}

void SegmentGrab::save(const char *filename) throw (Systemerror,Error)
{
    int fd=::open(filename,O_RDWR|O_CREAT,0x666);
    if(fd<0) throw Systemerror(errno,"open","SegmentGrab::save(%s):%m",filename);
    if(fileoffset_!=0)
    {
	off_t r=::lseek(fd,fileoffset_,SEEK_SET);
	if(r==(off_t)(-1))
	{
	  throw Systemerror(errno,"lseek","SegmentGrab::save: lseek(%s,%x):%m",			      filename,fileoffset_);
	}
    }
    ssize_t tw = (segoffset_+seg_.size() > 4096 ? 4096 : segoffset_+seg_.size());
    ssize_t nw = ::write(fd,puffer,tw);
    if(nw < 0) throw Systemerror(errno,"write",
				 "SegmentGrab::save: write(%s):%m",filename);
    if(nw<tw) 
    {
	throw Error("SegmentGrab::write: only %d bytes written (%d)",nw,tw);
    }
    ::close(fd);
}
