#ifndef RACE_LOGMSG_BSYSLOG_H
#define RACE_LOGMSG_BSYSLOG_H
#include<ace/Synch.h>
#include"RACE_LogMsg_Backend.h"
#include<syslog.h>

//##Documentation
//## Using the unix syslog mechanism as backend
class RACE_LogMsg_Bsyslog : public RACE_LogMsg_Backend
{
public:
    RACE_LogMsg_Bsyslog() {}
    ~RACE_LogMsg_Bsyslog();
    //##Documentation
    //## initialization with facility - see syslog(3)
    RACE_LogMsg_Bsyslog(const char *argv0,int facility);

    //##Documentation
    //## initialization with facility - see syslog(3)
    void open(const char *ident,int option,int facility);

    //##Documentation
    //## Implementation of a inherited abstract method
    virtual void write(int priority,const char *buffer,int len);
private:
    ACE_Thread_Mutex mutex_;
};
#endif
