#include"errorhandling.h"
#include<RACE/RACE_Thread.h>
//#define THREADTEST 1
//#define FATALTEST 1
//#define SIGNAL_TEST 1

class Global
{
public:
    Global()
	{
	    ERRLOG << "Global Constructor" << E_EOM;
	}

    ~Global()
	{
	    ERRLOG << E_CLR << "Global Destructor" << E_EOM;
	}
} global;

#ifdef THREADTEST
class TestThread : public RACE_Thread
{
public:
    TestThread(int nr):RACE_Thread("TestThread"),nr_(nr)
    {
	ERRLOG << E_CLR << "TestThread(" << nr_ << ")" << E_EOM;
    }
    ~TestThread()
    {
	ERRLOG << E_CLR << "~TestThread(" << nr_ << ")" << E_EOM;
    }
protected:
    virtual void run();
private:
    int nr_;
};

void TestThread::run()
{
#ifndef SIGNAL_TEST
    for(int i=0;i<1000;i++)
    {
	ERRLOG << "Thread " << nr_
	       << "(@TID/@PID) macht " << " eine " << " Ausgabe" << " in @FILE:@LINE @PROG" << E_EOM;
    }
#endif
#ifdef FATALTEST
    RACE_COND_FAIL(nr_==2,"Test for FATAL ERROR in thread %d ",nr_);
#endif
}
#endif

void onsignal(int signum, siginfo_t *sinfo, void *context)
{
    ERRLOG << "Signal " << signum << "received" << std::endl;
}

int main(int argc,char **argv)
{
#ifdef SIGNAL_TEST
    struct sigaction saction;
    saction.sa_sigaction = onsignal;
    sigemptyset(&(saction.sa_mask));
    saction.sa_flags = SA_SIGINFO;
    sigaction(SIGABRT,&saction,0);  
#endif    
    double d = 3.14519;
    int i =7;
    RACE_LOGMSGBACKEND::instance()->init(argc,argv);
    RACE_LOGMSGBACKEND::instance()->clear();
    RACE_LOGMSGBACKEND::instance()->addBackend(new RACE_LogMsg_Bsyslog(argv[0],LOG_LOCAL7));
    RACE_LOGMSGBACKEND::instance()->addBackend(new RACE_LogMsg_Bstderr());
    

    ERRLOG << RACE_LogMsg_Stream::WARNING << "@FILE:@LINE: @PID/@TID " << "Es funktioniert " << d << ':' << i << E_EOM;
    ERRLOG 
       << " EMERGENCY=" << (int)RACE_LogMsg_Stream::EMERGENCY  
       << " ALERT=" << (int)RACE_LogMsg_Stream::ALERT  
       << " CRIT=" << (int)RACE_LogMsg_Stream::CRIT   
       << " ERROR=" << (int)RACE_LogMsg_Stream::ERROR  
       << " WARNING=" << (int)RACE_LogMsg_Stream::WARNING  
       << " NOTICE=" << (int)RACE_LogMsg_Stream::NOTICE  
       << " INFO=" << (int)RACE_LogMsg_Stream::INFO  
       << " DEBUG=" << (int)RACE_LogMsg_Stream::LDEBUG
       << std::endl;

#ifdef THREADTEST
    TestThread *t1 = new TestThread(1);
    TestThread *t2 = new TestThread(2);
    t1->start();
    t2->start();
    t1->wait();
    t2->wait();
    ERRLOG << E_CLR << "----------------- ENDE ------ " << E_EOM;
    delete t1;
    delete t2;
#endif
}
