#include<errorhandling/errorhandling.h>
#include"RACE_Interpreter.h"
#include"logfilelayout.h"
#include"KVDumpable.h"
#include"KVSnapshotDumpable.h"
#include"KVInterpreter.h"
#include<iostream>

static envdebug *debug = new envdebug("KVInterpreter");
RACE_Dumpable *KVInterpreter::interpret(RACE_Data_Block *db,bool fragmented,RACE_LogfileOffset lo)
{
  RACE_Dumpable *ret;
  Logfile::Header *header = (Logfile::Header *)(db->begin());
  debug->print("Type %d",header->elementtype);
  switch(header->elementtype)
  {
  case   Logfile::KV_Type:
    debug->print("KVDumpable");
    ret=new KVDumpable(db,fragmented,lo);
    break;
  case  Logfile::Snapshot_Type:
    debug->print("KVSnapshotDumpable");
    ret=new KVSnapshotDumpable(db,fragmented,lo);
    break;
  default:
    RACE_WARN("KVInterpreter::interpret: Unknown Dumpable %d",header->elementtype);
    ret=new RACE_Dumpable(db,fragmented,lo);
  }
  RACE_MEMORY_FAIL(ret==NULL,__FILE__,__LINE__,__FUNCTION__);

  return ret;
}

