#ifndef LOGFILELAYOUT_H
#define LOGFILELAYOUT_H
#include"RACE_LogfileOffset.h"
#include"KVBaseTypes.h"

namespace Logfile
{
  enum ElementType { KV_Type=1, Snapshot_Type=2 };
  struct Header
  {
    size_t      len;
    ElementType elementtype;
  };

  struct KVEntry
  {
    Header h;  // Avoid Inheritance
    size_t keylen;
    size_t vallen;
    Timestamp_t timestamp;
    char key[0]; // Variable length
  };

  struct KeyRecord
  {
    size_t reclen; // including alignment at end
    RACE_LogfileOffset offset;
    size_t keylen; // real keylen
    char key[0];   // Variable length
  };

  struct KVSnapshotEntry
  {
    Header h;  // Avoid Inheritance
    KeyRecord keyrecords[0]; // Variable length
  };
};
#endif

