#include<errorhandling/errorhandling.h>
#include<iostream>
#include<stdio.h>
#include<string.h>
#include<getopt.h>
#include<ctype.h>
#include"Collector.h"

int parsekeyval(char *&keystr,int &klen,char *&valstr,int &vlen,int foldcase,char *line);

const int PUFLEN=1024;
char puffer[PUFLEN];
int zeile;
char *progname=NULL;
char *inputfile="STDIN";

void usage()
{
  std::cerr << "Aufruf: " << progname << " [-l] [-v] [-f] rumpfpfad" << std::endl;
  exit(1);
}

int main(int argc,char **argv)
{
  int c;
  int verbose=0;
  int foldcase=0;
  int genlog=0;
  FILE *fp=stdin;
  //Dmap *map=NULL;
  Collector *map=NULL;
  //char *maptypstr=NULL;
  progname=argv[0];
  Gdat key(NULL,0);
  Gdat val(NULL,0);

  while((c=getopt(argc,argv,"vlf"))!=-1)
  {
    switch(c)
    {
    case 'v': verbose=1;
      break;
    case 'f': foldcase=1;
      break;
    case 'l': genlog=1;
      break;
    case '?':
    default:
      usage();
    }
  }
  //if(argc-optind<2) usage();
  if(argc-optind<1) usage();
  const char *rumpfpfad = argv[optind];
  try
  {
    map=new Collector(rumpfpfad,genlog);
    RACE_COND_FAIL(map==NULL,"%s:%d: No Memory",__FILE__,__LINE__);
    map->open();
    /*------- Lesen der Datei ---------- */
    zeile=0;
    Timestamp_t timestamp;
    while(fgets(puffer,PUFLEN,fp)!=NULL)
    {
      char *keystr;int klen;
      char *valstr;int vlen;
      char *p;
      zeile++;
      if(strncmp(puffer,"kill",4)==0)
      {
        kill(getpid(),9);
      } else
      if(strncmp(puffer,"checkpoint",10)==0)
      {
        map->Checkpoint();
        continue;
      }
      timestamp=0;
      timestamp=(long long)strtol(puffer,&p,10);
      while(isspace(*p)) p++;
      if(parsekeyval(keystr,klen,valstr,vlen,foldcase,p)<0) continue;
      if(verbose)
      {
        fprintf(stderr,"key=\"%s\"  val=\"%s\"\n",keystr,valstr);
      }
      try
      {
        key.set(keystr,klen);
        val.set(valstr,vlen);
        if(timestamp)
        {
          timestamp<<=32;
          map->store(key,timestamp,val,DMAP_INSERT);
        }
        else
        {
          map->store(key,val,DMAP_INSERT);
        }
      }
      catch(std::exception& err)
      {
        fprintf(stderr,"Exception: %s\n",err.what());
      }
    }
    if(verbose)
    {
      std::cout << "---------Ascii Dump ----------------" << std::endl;
      map->asciidump(std::cout);
    }
    map->close();
    map->release();
  }
  catch(std::exception& err)
  {
    fprintf(stderr,"Exception: %s\n",err.what());
  }
}

int parsekeyval(char *&keystr,int &klen,char *&valstr,int &vlen,int foldcase,char *line)
{
  char *p=line;
  if(isascii(*p) && isspace(*p))
  {
    fprintf(stderr,"%s: %s: line %d: syntax error (leading space)\n",
                                progname, inputfile, zeile);
    return -1;
  }
  keystr=p;
  while(*p!='\0' && !(isascii(*p) && isspace(*p)))
  {
    if(foldcase &&(isascii(*p) && isupper(*p)))
    {
      *p = tolower(*p);
    }
    p++;
  }
  klen=p-keystr;
  if(*p=='\0')
  {
    vlen=0;
    valstr=p;
    fprintf(stderr,"%s: %s: line %d: No space and no value\n",
                                progname, inputfile, zeile);
    return -1;
  }
  *p='\0';
  p++;
  while(isspace(*p)) p++;
  if(*p=='\0')
  {
    fprintf(stderr, "%s: %s: line %d: no RHS for LHS %s\n",
            progname, inputfile, zeile, keystr);
    return -1;
  }
  valstr=p;
  while(*p!='\0' && *p!='\n' && *p!='\r') p++;
  *p='\0';
  vlen=p-valstr;
  return 0;
}

