#ifndef CACTIVECONSUMER_H
#define CACTIVECONSUMER_H
#include "RACE_Dumpable.h"
#include "RACE_LoggerQLS.h"
#include "RACE_Synch_Task.h"
#include <errorhandling/envdebug.h>


//##Documentation
//## This simulates the consumtion of dumpables
//##
class ActiveConsumer : public RACE_Synch_Task
{
public:
  ActiveConsumer():RACE_Synch_Task(&m_qls,0),m_canceled(false),m_qls("ActiveConsumer"),m_refcount(1) {}
  //##Documentation
  //## this is the main operation in the view of the client
  //## for example Log
  //## returns 0 in normal caeses, -1 in TIMEOUT case
  int DoWork(RACE_Dumpable *dumpable);

  //##Documentation
  //## It cancels the excecution
  void Cancel();
  ActiveConsumer *Duplicate();
  void Release();
  //##Documentation
  //## the thread
  virtual int svc(void);

  static envdebug *ms_debug;
private:
  bool m_canceled;
  RACE_LoggerQLS m_qls;
  int m_refcount;
};
#endif

