#include<time.h>
#include<iostream>
#include<errorhandling/errorhandling.h>
#include"ActiveConsumer.h"
#include"RACE_LogfileReader.h"
#include"RACE_Interpreter.h"
#include"RACE_WaitingFullBufferHandling.h"

int main(int argc,char**argv)
{
  RACE::Interpreter *interp = new RACE::Interpreter();
  RACE::LogFileReader reader(interp,new RACE::WaitingFullBufferHandling());
  ActiveConsumer *ac=new ActiveConsumer();
  RACE_Dumpable *dumpable;
  int retry=0;
  if(argc<2)
  {
      std::cerr << "Usage: " << argv[0] << " logfile " << std::endl;
      exit(1);
  }
  ac->activate();
  reader.Open(argv[1]);
  do
  {
    try
    {
      while((dumpable=reader.Read())!=NULL)
      {
        ac->DoWork(dumpable);
      }
    }
    catch(RACE::ReadError& ex)
    {
        std::cerr << "ReadError: " << ex.what() << std::endl;
    }
  } while(retry>0);
  reader.Close();
  ac->Cancel();
  ac->Release();
  ACE_Thread_Manager::instance()->wait();
  std::cerr << "done" << std::endl;
  return 0;
}
