#ifndef ENV_ACCESS_H_
#define ENV_ACCESS_H_

/*
 * $Id: env_access.h,v 1.3 2004/04/22 15:18:36 okellogg Exp $
 */

#include <errorhandling/string_parser.h>
#include <errorhandling/string_parser_impl_template.h>

//##Documentation
//## Implements the interface class string_parser_base for environment variables.
class env_adapter : public string_parser_base {
  public:
    env_adapter (const char* env_variable_name);

    virtual std::string get_str () const;
    virtual ~env_adapter () {}
  private:
    env_adapter ();
    env_adapter (const env_adapter&);
    env_adapter& operator= (const env_adapter&);

    std::string env_variable_content;
};

typedef string_parser_impl_template<string_list_parser, env_adapter> env_list;
typedef string_parser_impl_template<string_flag_parser, env_adapter> env_flag;
typedef string_parser_impl_template<string_level_parser, env_adapter> env_level;

#endif


