#include"RACE_Log_Msg_Stream.h"
#include<RACE/RACE_Thread.h>

class Global
{
public:
    Global()
	{
	    ERRLOG << E_CLR << "Global Constructor" << std::endl;
	}

    ~Global()
	{
	    ERRLOG << E_CLR << "Global Destructor" << std::endl;
	}
} global;

class TestThread : public RACE_Thread
{
public:
    TestThread(int nr):nr_(nr)
    {
	ERRLOG << E_CLR << "TestThread(" << nr_ << ")" << E_EOM;
    }
    ~TestThread()
    {
	ERRLOG << E_CLR << "~TestThread(" << nr_ << ")" << E_EOM;
    }
protected:
    virtual void run();
private:
    int nr_;
};

void TestThread::run()
{
    for(int i=0;i<1000;i++)
    {
	ERRLOG << E_CLR << "Thread " << nr_
	       << " macht " << " eine " << " Ausgabe" << "in %N:%l %P %n" << E_EOM;
    }
}

int main(int argc,char **argv)
{
    double d = 3.14519;
    int i =7;
    RACELOGMSGSTREAM::instance()->open(argv[0],ACE_Log_Msg::STDERR|ACE_Log_Msg::SYSLOG);
    ERRLOG << E_CLR 
	   << LM_WARNING
	   << "%N:%l: %P %n " << "Es funktioniert " << d << ':' << i << E_EOM;
    TestThread *t1 = new TestThread(1);
    TestThread *t2 = new TestThread(2);
    t1->start();
    t2->start();
    RACE_Thread::wait_for_all_threads();
    ERRLOG << E_CLR << "----------------- ENDE ------ " << E_EOM;
    delete t1;
    delete t2;
}
